%define target avr

Name:           %{target}-gcc
Version:        4.4.2
Release:        %mkrel 1
Summary:        Cross Compiling GNU GCC targeted at %{target}
Group:          Development/Languages
License:        GPLv2+
URL:            http://gcc.gnu.org/
Source0:        ftp://ftp.gnu.org/gnu/gcc/gcc-%{version}/gcc-core-%{version}.tar.bz2
Source1:        ftp://ftp.gnu.org/gnu/gcc/gcc-%{version}/gcc-g++-%{version}.tar.bz2

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}
BuildRequires:  %{target}-binutils >= 2.13, zlib1-devel gawk libgmp-devel libmpfr-devel
Requires:       %{target}-binutils >= 2.13

%description
This is a Cross Compiling version of GNU GCC, which can be used to
compile for the %{target} platform, instead of for the
native %{_arch} platform.


%package c++
Summary:        Cross Compiling GNU GCC targeted at %{target}
Group:          Development/Languages
Requires:       %{name} = %{version}-%{release}

%description c++
This package contains the Cross Compiling version of g++, which can be used to
compile c++ code for the %{target} platform, instead of for the native %{_arch}
platform.


%prep
%setup -q -c -a 1
pushd gcc-%{version}

sed -i 's/VERSUFFIX ""/VERSUFFIX " (Fedora %{version}-%{release})"/' \
  gcc/version.c
contrib/gcc_update --touch
popd


# Extract %%__os_install_post into os_install_post~
cat << \EOF > os_install_post~
%__os_install_post
EOF

# Generate customized brp-*scripts
cat os_install_post~ | while read a x y; do
case $a in
# Prevent brp-strip* from trying to handle foreign binaries
*/brp-strip*)
  b=$(basename $a)
  sed -e 's,find $RPM_BUILD_ROOT,find $RPM_BUILD_ROOT%{_bindir} $RPM_BUILD_ROOT%{_libexecdir},' $a > $b
  chmod a+x $b
  ;;
esac
done

sed -e 's,^[ ]*/usr/lib/rpm.*/brp-strip,./brp-strip,' \
< os_install_post~ > os_install_post 


%build
mkdir -p gcc-%{target}
pushd gcc-%{target}
CC="%{__cc} ${RPM_OPT_FLAGS}" \
../gcc-%{version}/configure --prefix=%{_prefix} --mandir=%{_mandir} \
  --infodir=%{_infodir} --target=%{target} --enable-languages=c,c++ \
  --disable-nls --disable-libssp --with-system-zlib \
  --enable-version-specific-runtime-libs
# In general, building GCC is not smp-safe
make
popd


%install
rm -rf $RPM_BUILD_ROOT
pushd gcc-%{target}
make install DESTDIR=$RPM_BUILD_ROOT
popd
# we don't want these as we are a cross version
rm -r $RPM_BUILD_ROOT%{_infodir}
rm -r $RPM_BUILD_ROOT%{_mandir}/man7
rm    $RPM_BUILD_ROOT%{_libdir}/libiberty.a
# and these aren't usefull for embedded targets
rm -r $RPM_BUILD_ROOT/usr/libexec/gcc/%{target}/%{version}/install-tools

%define __os_install_post . ./os_install_post


%clean
rm -rf $RPM_BUILD_ROOT


%files
%defattr(-,root,root,-)
%doc gcc-%{version}/COPYING gcc-%{version}/COPYING.LIB
%doc gcc-%{version}/README
%{_bindir}/%{target}-*
/usr/lib/gcc/%{target}/%{version}
#%{_libexecdir}/gcc/%{target}/%{version}
%{_mandir}/man1/%{target}-*.1.bz2
%exclude %{_bindir}/%{target}-?++
# This spec uses libexecdir that points to /usr/lib
%exclude /usr/libexec/gcc/%{target}/%{version}/cc1plus
%exclude %{_mandir}/man1/%{target}-g++.1.bz2
/usr/libexec/gcc/%{target}/%{version}/cc1
/usr/libexec/gcc/%{target}/%{version}/collect2


%files c++
%defattr(-,root,root,-)
%{_bindir}/%{target}-?++
# This spec uses libexecdir that points to /usr/lib
/usr/libexec/gcc/%{target}/%{version}/cc1plus
%{_mandir}/man1/%{target}-g++.1.bz2


%changelog
* Mon Dec 28 2009 MBantz <martin.bantz at gmail dot com>
- Adapted to PCLinuxOS from tnorth at fedoraproject dot org
